public class LinkedList {

    class ListNode {

        ListNode next;
        Object item;

        ListNode(Object item) {
            this.item = item;
            next = null;
        }
    }

    private ListNode start;

    public LinkedList() {
        start = null;
    }

    public LinkedList push(Object obj) {
        ListNode node = new ListNode(obj);
        if (start == null) {
            start = node;
        } else {
            node.next = start;
            start = node;
        }
        return this;
    }

    public Object pop() {
        Object ret = null;
        if (start != null) {
            ret = start.item;
            start = start.next;
        }
        return ret;
    }

    public int size() {
        int count = 0;
        ListNode cur = start;
        while (cur != null) {
            cur = cur.next;
            count++;
        }
        return count;
    }

    public Object back() {
        ListNode end = start;
        while (end != null && end.next != null) {
            end = end.next;
        }
        return end == null ? null : end.item;
    }

    private ListNode getNode(int index) {
        ListNode cur = start;
        int i = 0;
        while (i < index && cur != null && cur.next != null) {
            cur = cur.next;
            i++;
        }
        return cur;
    }

    public void insertAt(Object obj, int index) {
        if (index < 0) {
            return;
        }
        ListNode newNode = new ListNode(obj);
        ListNode node = getNode(index - 1);
        if (node == start) {
            start = newNode;
        }
        if (node != null) {
            newNode.next = node.next;
            node.next = newNode;
        }
    }

    public void print() {
        ListNode cur = start;
        while (cur != null) {
            System.out.print(cur.item + (cur.next == null ? "\n" : " "));
            cur = cur.next;
        }
    }

    public Object getAt(int index) {
        if (index < 0 || start == null) {
            return null;
        }
        ListNode cur = start;
        int i = 0;
        while (i < index && cur != null && cur.next != null) {
            cur = cur.next;
            i++;
        }
        return (cur != null && i == index) ? cur.item : null;
    }

    public void removeAt(int index) {
        if (index < 0 || start == null) {
            return;
        }
        if (index == 0) {
            pop();
        } else {
            ListNode node = getNode(index - 1);
            if (node.next != null) {
                node.next = node.next.next;
            }
        }
    }

    public int indexOf(Object obj) {
        int count = 0;
        ListNode cur = start;
        boolean found = false;
        while (cur != null && !found) {
            found = cur.item.equals(obj);
            cur = cur.next;
            count++;
        }
        return found ? count - 1 : -1;
    }

}
